﻿//#define IsTestDownLevel3
#define IsDriverUpperSystemFuncV1
#define IsDriverUpperSystemFuncV2

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FunctionSystem
{
    public static class Level3
    {
#if IsTestDownLevel3

        #region заглушки

        public static double SystemFuncV1(double x) => 1;

        public static double SystemFuncV2(double x) => 0;

        #endregion

#else

#if IsDriverUpperSystemFuncV1

        public static double SystemFuncV1(double x)
        {
            Console.WriteLine($"Ctg - {Level2.Ctg(x)}");
            Console.WriteLine($"Sec - {Level2.Sec(x)}");
            Console.WriteLine($"Tan - {Level2.Tan(x)}");
            Console.WriteLine($"Sin - {Level0.Sin(x)}");
            Console.WriteLine($"Cos - {Level1.Cos(x)}");
            return 0;
        }

#else

        public static double SystemFuncV1(double x)
        {
            return ((((((Level2.Ctg(x)) / Level2.Sec(x)) - Level2.Tan(x)) * Level0.Sin(x)) / (Level1.Cos(x))) * (Math.Pow(((Level0.Sin(x) + Level1.Cos(x)) + Level1.Cos(x)), 2)));
        }

#endif

#if IsDriverUpperSystemFuncV2

        public static double SystemFuncV2(double x)
        {
            Console.WriteLine($"Log - {Level2.Log(x, 2)}");
            Console.WriteLine($"Ln - {Level0.Ln(x)}");
            return 0;
        }

#else

        public static double SystemFuncV2(double x)
        {
            return ((((Math.Pow(Level2.Log(x, 5), 3) * Level2.Log(x, 10)) + Level2.Log(x, 3))/(Level0.Ln(x))) + (Level0.Ln(x) * Level2.Log(x, 5)));
        }

#endif

#endif
    }
}
